﻿using StudyCrafter.Assistant.Representation;
using StudyCrafter.Assistant.StudyCrafterScenario;

namespace StudyCrafter.Assistant.Metrics
{
    public class AverageNumChoicesPerScene : InteractionMetric
    {
        public AverageNumChoicesPerScene(IGraphStore store) : base(store)
        {
        }

        protected override void CalculateForGraph(InteractionMap graph)
        {
            int numChoices = 0;
            foreach (InteractionEdge edge in graph.Graph.Edges)
            {
                if (edge.EdgeType == InteractionEdge.Type.Choice)
                {
                    numChoices++;
                }
            }

            AccumulateMetric(numChoices);
        }
    }
}
