﻿using System.Collections.Generic;
using StudyCrafter.Assistant.Representation;
using StudyCrafter.Assistant.StudyCrafterScenario;

namespace StudyCrafter.Assistant.Metrics
{
    public class FeedbackPerChoice : RatioInteractionMetric
    {
        public FeedbackPerChoice(IGraphStore store) : base(store)
        {
        }

        protected override void CalculateForGraph(InteractionMap graph)
        {
            int numFeedback = 0;
            HashSet<string> interactionUnits = new HashSet<string>();
            foreach (InteractionNode node in graph.Graph.Vertices)
            {
                if (node.NodeType == InteractionNode.Type.Feedback)
                {
                    numFeedback++;
                }
            }

            int numChoices = 0;
            foreach (InteractionEdge edge in graph.Graph.Edges)
            {
                if (edge.EdgeType == InteractionEdge.Type.Choice)
                {
                    numChoices++;
                }
            }

            AccumulateRatioDenominator(numChoices);
            AccumulateMetric(numFeedback);
        }
    }
}
