﻿using System.Collections.Generic;
using StudyCrafter.Assistant.Representation;
using StudyCrafter.Assistant.StudyCrafterScenario;

namespace StudyCrafter.Assistant.Metrics
{
    public class IntraPlaythroughDiversity : SimulatedPlaytraceMetric
    {
        private HashSet<InteractionEdge> visitedActions = new HashSet<InteractionEdge>();

        public IntraPlaythroughDiversity(IGraphStore store) : base(store)
        {
        }

        protected override void OnTreeEdge(InteractionEdge edge)
        {
            if (edge.Source.NodeType == InteractionNode.Type.InteractionPoint)
            {
                visitedActions.Add(edge);
            }
        }

        protected override void OnStartPlaythrough(int playthroughNum)
        {
            visitedActions.Clear();
        }

        protected override void OnCompletePlaythrough(int playthroughNum)
        {
            AccumulateMetric(visitedActions.Count);
        }

        private void AccumulateMetric(double thisSession)
        {
            Result += thisSession / (double)NumPlaythroughs;
        }
    }
}
