﻿using System.Collections;
using System.Collections.Generic;

namespace StudyCrafter.Assistant.Metrics
{
    public class MetricResultsCollection : IDictionary<string, double>
    {
        private IDictionary<string, double> results = new Dictionary<string, double>();

        public double this[string key]
        {
            get
            {
                return results[key];
            }
            set
            {
                results[key] = value;
            }
        }

        public ICollection<string> Keys
        {
            get
            {
                return results.Keys;
            }
        }

        public ICollection<double> Values
        {
            get
            {
                return results.Values;
            }
        }

        public int Count
        {
            get
            {
                return results.Count;
            }
        }

        public bool IsReadOnly
        {
            get
            {
                return results.IsReadOnly;
            }
        }

        public void Add(string key, double value)
        {
            results.Add(key, value);
        }

        public void Add(KeyValuePair<string, double> item)
        {
            results.Add(item);
        }

        public void Clear()
        {
            results.Clear();
        }

        public bool Contains(KeyValuePair<string, double> item)
        {
            return results.Contains(item);
        }

        public bool ContainsKey(string key)
        {
            return results.ContainsKey(key);
        }

        public void CopyTo(KeyValuePair<string, double>[] array, int arrayIndex)
        {
            results.CopyTo(array, arrayIndex);
        }

        public IEnumerator<KeyValuePair<string, double>> GetEnumerator()
        {
            return results.GetEnumerator();
        }

        public bool Remove(string key)
        {
            return results.Remove(key);
        }

        public bool Remove(KeyValuePair<string, double> item)
        {
            return results.Remove(item);
        }

        public bool TryGetValue(string key, out double value)
        {
            return results.TryGetValue(key, out value);
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return results.GetEnumerator();
        }
    }
}
