﻿using StudyCrafter.Assistant.Representation;

namespace StudyCrafter.Assistant.Metrics
{
    public abstract class OverallRatioGraphMetric<T> : PerSceneGraphMetric<T>
    {
        private double denominatorValue;

        protected OverallRatioGraphMetric(IGraphStore store) : base(store)
        {
        }

        protected virtual void AccumulateRatioDenominator(double value)
        {
            denominatorValue += value;
        }

        protected override double ModifyTotal(double total, int numGraphs)
        {
            if (denominatorValue <= 0)
            {
                denominatorValue = 1;
            }

            return total / denominatorValue;
        }
    }
}
