﻿using StudyCrafter.Assistant.Representation;
using StudyCrafter.Assistant.StudyCrafterScenario;

namespace StudyCrafter.Assistant.Metrics
{
    public class TextPerDialogNode : RatioScriptMetric
    {
        public TextPerDialogNode(IGraphStore store) : base(store)
        {
        }

        protected override void CalculateForGraph(ScriptGraph graph)
        {
            int numNodes = 0;
            int textLength = 0;
            foreach (ScriptNode node in graph.Graph.Vertices)
            {
                if (node.Type == ScriptNodeTypes.Dialogue || node.Type == ScriptNodeTypes.Choice)
                {
                    // Count the node.
                    numNodes++;

                    StringExpressionProperty dialogueText;
                    if (!node.TryGetProperty("content", out dialogueText))
                    {
                        continue;
                    }

                    // Count the text length. NOTE: Variables count as text length, though it should really be their current value at execution time...
                    textLength += dialogueText.Val.Length;
                }
            }

            AccumulateRatioDenominator(numNodes);
            AccumulateMetric(textLength);

        }
    }
}
