﻿
using QuickGraph;

namespace StudyCrafter.Assistant.Representation
{
    public class BaseGraphOwner<TVertex, TEdge> : IGraphOwner<TVertex, TEdge> where TEdge : IEdge<TVertex>
    {
        private GraphID id;
        protected IMutableBidirectionalGraph<TVertex, TEdge> graph;

        public IMutableBidirectionalGraph<TVertex, TEdge> Graph
        {
            get
            {
                return graph;
            }
        }

        public GraphID ID
        {
            get
            {
                return id;
            }
        }

        public BaseGraphOwner(GraphID id)
        {
            this.id = id;
        }

        public BaseGraphOwner()
        {
            this.id = GraphID.None;
        }

        public void SetID(GraphID id)
        {
            this.id = id;
        }
    }
}
