﻿
using System;

namespace StudyCrafter.Assistant.Representation
{
    public class GraphID : IEquatable<GraphID>
    {
        private readonly int id = 0;

        public static readonly GraphID None = new GraphID(0);

        public GraphID(int id)
        {
            this.id = id;
        }

        public override bool Equals(object obj)
        {
            GraphID otherID = obj as GraphID;
            if (object.ReferenceEquals(otherID, null))
            {
                return false;
            }

            return otherID.id == this.id;
        }

        public bool Equals(GraphID other)
        {
            if (object.ReferenceEquals(other, null))
            {
                return false;
            }

            return other.id == this.id;
        }

        public static bool operator ==(GraphID self, GraphID other)
        {
            if (object.ReferenceEquals(self, null) || object.ReferenceEquals(other, null))
            {
                return object.ReferenceEquals(self, null) && object.ReferenceEquals(other, null);
            }

            return self.id == other.id;
        }

        public static bool operator !=(GraphID self, GraphID other)
        {
            return !(self == other);
        }

        public override int GetHashCode()
        {
            return id.GetHashCode();
        }

        public override string ToString()
        {
            return id.ToString();
        }
    }
}
