﻿using System;
using UnityEngine;

namespace StudyCrafter.Assistant.Representation
{
    public class ExpressionProperty : IProperty
    {
        public ExpressionProperty(string id, string val)
        {
            ID = id;
            Val = val;
        }

        public string ID
        {
            get;
            private set;
        }

        public string Val
        {
            get
            {
                return ExpressionString;
            }
            private set
            {
                ExpressionString = value;
            }
        }

        private string fullString;
        public string ExpressionString
        {
            get
            {
                return fullString;
            }
            private set
            {
                fullString = value;

                if (null == value)
                {
                    Root = null;
                    return;
                }

                try
                {
                    this.FromString(value);

                }
                catch (Sprache.ParseException e)
                {
                    throw new System.ArgumentException("Error: could not parse expression: " + fullString, e);
                }
            }
        }

        public IOperand Root
        {
            get;
            set;
        }
    }
}

