﻿
namespace StudyCrafter.Assistant.Representation
{
    public class LayoutObjectProperty : IProperty
    {
        private string objectName;
        private string fullValue;

        public LayoutObjectProperty(string id, string val)
        {
            ID = id;
            Val = val;
        }

        public string ID
        {
            get;
            private set;
        }

        public string Val
        {
            get
            {
                return fullValue;
            }
            private set
            {
                fullValue = value;
                LayoutObjectName = fullValue;
            }
        }

        public string LayoutObjectName
        {
            get
            {
                return objectName;
            }
            set
            {
                if (null == value)
                {
                    objectName = value;
                }
                else
                {
                    objectName = value.Trim(VariableProperty.NameDelimiters);
                }
            }
        }
    }
}
