﻿using Newtonsoft.Json;

namespace StudyCrafter.Assistant.Representation
{
    [JsonObject(MemberSerialization = MemberSerialization.OptIn)]
    public class PropertyDefinition
    {
        [JsonProperty]
        public string Name { get; private set; }

        [JsonProperty]
        [JsonConverter(typeof(Newtonsoft.Json.Converters.StringEnumConverter))]
        public PropertyType Type { get; private set; }

        [JsonProperty]
        public string Value { get; private set; }

        public IProperty Property
        {
            get
            {
                return PropertyFactory.OfType(Type, Name, Value);
            }
        }


        public IProperty PropertyWithValue(string overrideValue)
        {
            return PropertyFactory.OfType(Type, Name, overrideValue);
        }
    }
}