﻿using System.Collections.Generic;

namespace StudyCrafter.Assistant.Representation
{
    public class SequentialIDGenerator : IGraphIDGenerator
    {
        HashSet<GraphID> usedIDs = new HashSet<GraphID>();

        int nextID = 0;

        public SequentialIDGenerator()
        {
        }

        void IGraphIDGenerator.RegisterGraph<TVertex, TEdge>(IGraphOwner<TVertex, TEdge> owner)
        {
            usedIDs.Add(owner.ID);
        }

        GraphID IGraphIDGenerator.GenerateID<TVertex, TEdge>(IGraphOwner<TVertex, TEdge> owner)
        {
            GraphID newID;
            do
            {
                newID = new GraphID(nextID);
                nextID++;
            }
            while (usedIDs.Contains(newID));

            return newID;
        }

    }
}
