﻿using StudyCrafter.Assistant.Loading;

namespace StudyCrafter.Assistant.StudyCrafterLoading
{
	public class ProjectLoadStatus
	{
		public LoadStatus Status
		{
			get;
			private set;
		}

		public string ErrorText
		{
			get;
			private set;
		}

		public ProjectLoadStatus()
		{
			Status = LoadStatus.None;
		}

		public void UpdateStatus(LoadStatus status)
		{
			Status = status;
		}

		public void NotifyError(string error)
		{
			ErrorText = error;
			UpdateStatus(LoadStatus.Error);
		}
	}

	public interface IProjectLoader
	{
		string ProjectsFolder { get; set; }

		ProjectLoadStatus LoadProject(string projectName);

		ProjectLoadStatus GetStatus(string projectName);

		JsonScenarioStrings GetLoadedProject(string projectName);
	}
}
