﻿using QuickGraph;
using StudyCrafter.Assistant.Representation;
using StudyCrafter.Assistant.StudyCrafterScenario;

namespace StudyCrafter.Assistant.StudyCrafterLoading
{
    public class JSonSceneGraphBuilder : IGraphBuilder<SceneGraph, Scene, IEdge<Scene>>
    {
        private JsonScenarioStrings strings;
        private StudyCrafterLoadHelpers loadHelpers;

        public JSonSceneGraphBuilder(JsonScenarioStrings strings, StudyCrafterLoadHelpers loadHelpers)
        {
            this.strings = strings;
            this.loadHelpers = loadHelpers;
        }

        public SceneGraph Build()
        {
            SceneGraph graph = new SceneGraph()
                                    .AddStartScene(strings.RootJson)
                                    .BuildSceneGraph(strings.SceneJson, loadHelpers);

            graph.SetID(loadHelpers.IDGenerator.GenerateID(graph));

            loadHelpers.GraphStore.AddOwner(graph);

            return graph;
        }


    }
}
