﻿using System.Collections.Generic;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace StudyCrafter.Assistant.StudyCrafterLoading
{
    public class ScriptNodeSerializationData
    {
        [JsonProperty("type")]
        public string Type { get; set; }

        [JsonExtensionData]
        private Dictionary<string, JToken> properties = new Dictionary<string, JToken>();

        [OnDeserialized]
        public void OnDeserialized(StreamingContext context)
        {
        }

        public string GetProperty(string name)
        {
            return (string)properties[name];
        }

        public bool TryGetProperty(string name, out string resultValue)
        {
            JToken token;
            if (!properties.TryGetValue(name, out token))
            {
                resultValue = null;
                return false;
            }

            resultValue = token.Value<string>();
            return true;
        }

        public bool RemoveProperty(string name)
        {
            return properties.Remove(name);
        }

        public IEnumerable<string> GetPropertyNames()
        {
            return properties.Keys;
        }
    }
}