﻿using System;
using QuickGraph;
using StudyCrafter.Assistant.Representation;
using StudyCrafter.Assistant.StudyCrafterScenario;

namespace StudyCrafter.Assistant.StudyCrafterScenario
{
    public static class ScenarioExtensions
    {
        public static SceneGraph GetSceneGraph(this Scenario scenario, IGraphStore graphStore)
        {
            IGraphOwner<Scene, IEdge<Scene>> sceneGraphOwner;
            if (!graphStore.TryGetOwner(scenario.SceneGraph, out sceneGraphOwner))
            {
                return null;
            }

            return (SceneGraph)sceneGraphOwner;
        }
    }
}
