﻿using System;
using QuickGraph;
using StudyCrafter.Assistant.Representation;
using StudyCrafter.Assistant.StudyCrafterScenario;

namespace StudyCrafter.Assistant.StudyCrafterScenario
{
    public static class SceneExtensions
    {

        public static ScriptGraph GetScriptGraph(this Scene scene, IGraphStore graphStore)
        {
            IGraphOwner<ScriptNode, IEdge<ScriptNode>> scriptGraphOwner;
            if (!graphStore.TryGetOwner(scene.ScriptGraph, out scriptGraphOwner))
            {
                return null;
            }
            return (ScriptGraph)scriptGraphOwner;
        }

        public static LayoutGraph GetLayoutGraph(this Scene scene, IGraphStore graphStore)
        {
            IGraphOwner<LayoutNode, LayoutGraph.Edge> layoutGraphOwner;
            if (!graphStore.TryGetOwner(scene.LayoutGraph, out layoutGraphOwner))
            {
                return null;
            }
            return (LayoutGraph)layoutGraphOwner;
        }

        public static InteractionMap GetInteractionMap(this Scene scene, IGraphStore graphStore)
        {
            IGraphOwner<InteractionNode, InteractionEdge> interactionMapOwner;
            if (!graphStore.TryGetOwner(scene.InteractionMap, out interactionMapOwner))
            {
                return null;
            }
            return (InteractionMap)interactionMapOwner;
        }
    }
}
