﻿
using System;
using System.Collections.Generic;
using QuickGraph;
using StudyCrafter.Assistant.Representation;

namespace StudyCrafter.Assistant.StudyCrafterScenario
{
    public class SceneGraph : BaseGraphOwner<Scene, IEdge<Scene>>
    {
        private Scene root;
        public Scene Root
        {
            get
            {
                return root;
            }
            set
            {
                if (null != root)
                {
                    throw new InvalidOperationException(string.Format("Cannot set the root scene - it is already set: {0}", root));
                }
                root = value;
                graph.AddVertex(root);
            }
        }

        public int NumScenes
        {
            get { return graph.VertexCount; }
        }

        public SceneGraph() : base()
        {
            graph = new BidirectionalGraph<Scene, IEdge<Scene>>();
            root = null;
        }

        public IEnumerable<Scene> GetScenes()
        {
            return graph.Vertices;
        }
    }
}
