﻿
using System;
using StudyCrafter.Assistant.Representation;
using UnityEngine;

namespace StudyCrafter.Assistant.StudyCrafterScenario
{
    public class ScriptNode : BaseGraphNode
    {
        public string Type
        {
            get
            {
                StringProperty typeProp;
                if (!Properties.TryGet("type", out typeProp))
                {
                    Debug.LogError("No type for node " + ID);
                    return null;
                }
                return typeProp.Val;
            }
            set
            {
                SetProperty(new StringProperty("type", value));
            }
        }

        public ScriptNode(string ID) : base(ID)
        {
        }

        public override string ToString()
        {
            return string.Format("{0}: {1}", ID, Type);
        }
    }
}
