﻿
using System.Collections.Generic;
using Newtonsoft.Json;
using System.Linq;
using UnityEngine;

namespace StudyCrafter.Assistant.StudyCrafterScenario
{
    [JsonObject(MemberSerialization = MemberSerialization.OptIn)]
    public class ScriptNodeDefCollection
    {
        [JsonProperty]
        private List<ScriptNodeDefinition> Nodes
        {
            get; set;
        }

        public ScriptNodeDefCollection()
        {
        }

        public bool TryGetDefinition(string name, out ScriptNodeDefinition result)
        {
            IEnumerable<ScriptNodeDefinition> nodes = Nodes.Where((node) => node.Name == name);
            result = nodes.FirstOrDefault();
            return nodes.Any();
        }
    }
}
