﻿using UnityEngine;
using UnityEngine.UI;

namespace StudyCrafter.Assistant.UI
{
	public class PathController : MonoBehaviour
	{
		[SerializeField]
		public InputField textInput;

		private string filePath;
		public string FilePath
		{
			get
			{
				return filePath;
			}
			set
			{
				filePath = value;
				textInput.text = value;
				NotifyPathUpdated();
			}
		}

		public delegate void PathUpdated(string filePath);

		public event PathUpdated PathUpdatedListener;

		public PathController()
		{
		}

		public void NotifyPathUpdated()
		{
			if (null != PathUpdatedListener)
			{
				PathUpdatedListener(filePath);
			}
		}
	}
}