# StudyCrafter Analysis Assistant

### Submitted to AIIDE 2018 artifact evaluation to support the paper:

## "Exploratory Automated Analysis of Structural Features of Interactive  Narrative"

### Nathan Partlan, Elin Carstensdottir, Sam Snodgrass, Erica Kleinman, 
### Casper Harteveld, Gillian Smith, and Magy Seif El-Nasr

### Code by Nathan Partlan, 2017-2018


We would like to thank past and current members of the StudyCrafter team, 
and especially Dr. Camillia Matuk and Dr. Steven Sutherland. We further 
acknowledge the grant support from Northeastern University, 
NSF (IIS-1736185), and DARPA (D16AP0011).

---

# Installation:

On Windows:
Drag the "StudyCrafterAssistant" folder to your installation location of choice.
Double-click "StudyCrafterAssistant.exe" to run the tool.

On Mac:
Drag the "StudyCrafterAssistant.app" to your Applications folder.
Double-click "StudyCrafterAssistant.app" to run the tool.

On Linux:
Move the "StudyCrafterAssistant" folder to your installation location of choice.
Ensure the "StudyCrafterAssistant" executable has execute permissions, and run
it.

---

# Usage:

- Place one or more projects made using StudyCrafter into the
"StreamingAssets" directory (or a subdirectory thereof) inside the 
StudyCrafterAssistant directory. The project should be a folder that contains
multiple .json files.

  On a Windows or Linux build of StudyCrafter, these projects are located inside 
  the "StreamingAssets/NewProjectSystem" folder inside StudyCrafter_Data.

  Note: On a Mac build, this folder may be accessed by right-clicking on
  the "StudyCrafter.app," and selecting "Show Package Contents." Inside the 
  package, the projects are located in the folder: 
  "Contents/Resources/Data/StreamingAssets/NewProjectSystem"

- Open the "StudyCrafter Analysis Assistant" application.

- Specify the output location for the Representation Graphs in the 
"Representation Output Folder" text input field.

- Specify the output location for Metrics in the "Metrics Output Folder" text
input field.

- Specify the folder in which the projects are located, in the "Projects Folder"
text input field. Then, if you want to analyze all the projects in that folder,
press the "Analyze Directory" button.

- To analyze a single project, specify the name of the project in the "Project
Name" text input field. Then, click the "Analyze Single Project" button.
Note: Currently, you must analyze an individual project to produce the visual
representation graphs for that project.

- You should see the status indicator text return to "Finished" when the 
analysis is complete. You can then find the output metrics and/or representation
graphs in the specified folders.

---

# Building:

- Install Unity 2017.04, and either Visual Studio Code or MonoDevelop.

- Open the "StudyCrafterAssistant" folder as a project in Unity 2017.04

- Open the "Asset Store" window in Unity, and find "Json.NET for Unity".
Download and import it into your project.

  (This asset: https://assetstore.unity.com/packages/tools/input-management/json-net-for-unity-11347)

- Open the "TestPCGScene" scene.

- Press the "Play" button to run the tool.

- To build a distributable executable, use the File->Build menu to build
to the location of your choice.

# Building the Documentation

You can use Doxygen to build automatic HTML documentation for this project.

To build the documentation for this project, run "doxygen Doxyfile" in the base StudyCrafterAssistant folder.

The documentation will be found in the "Documentation" folder. The start page is "html/index.html"

---

# Code Organization:

The code is split into namespaces based on its functionality.

In the generic namespaces, without "StudyCrafter" in the name, is code that 
does not rely on any StudyCrafter-specific definitions or concepts.

- __Loading:__ For generic loading and file reading code.

- __Metrics:__ For generic metrics base classes.

- __Representation:__ For generic graph-based representation code.

- __StudyCrafterLoading:__ For StudyCrafter-specific project loading code.

- __StudyCrafterSaving:__ For StudyCrafter-specific file saving code.

- __StudyCrafterScenario:__ For StudyCrafter-specific project/scenario definition code.

- __StudyCrafterTypes:__ For StudyCrafter type definitions that tie to the actual StudyCrafter version of that type.

- __UI:__ For UI code.

---

# Libraries and Licenses:

This project includes libraries written by other authors. These are:

Sprache (https://github.com/sprache/Sprache)

QuickGraph (https://github.com/davidgutierrezpalma/quickgraph4unity)

They are redistributed in accordance with, and retain, their original licenses.
